from documente_shared.domain.entities import DocumentProcess
from documente_shared.domain.repositories import DocumentProcessRepository
from documente_shared.infrastructure.dynamo_table import DynamoDBTable
from python_layer.python.typing_extensions import Optional


class DynamoDocumentProcessRepository(
    DynamoDBTable,
    DocumentProcessRepository,
):
    def find(self, digest: str) -> Optional[DocumentProcess]:
        item = self.get(key=digest)
        if item:
            return DocumentProcess.from_dict(item)
        return None

    def persist(self, instance: DocumentProcess) -> DocumentProcess:
        self.put(instance.to_dict)
        return instance

    def remove(self, instance: DocumentProcess):
        self.delete(key={'digest': instance.digest})